%define anolis_release 1
%global _hardened_build 1

Name:     tftp
Version:  5.2
Release:  %{anolis_release}%{?dist}
License:  BSD
URL:      http://www.kernel.org/pub/software/network/tftp/
Source0:  http://www.kernel.org/pub/software/network/tftp/tftp-hpa/tftp-hpa-%{version}.tar.bz2
Source1:  tftp.socket
Source2:  tftp.service
Summary:  The client for the Trivial File Transfer Protocol (TFTP)

Patch0: 0001-tftp-0.40-remap.patch
Patch2: 0002-tftp-hpa-0.39-tzfix.patch
Patch3: 0003-tftp-0.42-tftpboot.patch
Patch4: 0004-tftp-0.49-chk_retcodes.patch
Patch5: 0005-tftp-hpa-0.49-fortify-strcpy-crash.patch
Patch6: 0006-tftp-0.49-cmd_arg.patch
Patch7: 0007-tftp-hpa-0.49-stats.patch
Patch8: 0008-tftp-hpa-5.2-pktinfo.patch
Patch9: 0009-tftp-doc.patch
Patch10: 0010-tftp-enhanced-logging.patch
Patch11: 0011-tftp-hpa-5.2-gcc10.patch
Patch12: 0012-tftp-off-by-one.patch
Patch13: 0013-tftp-c99.patch
Patch14: 0014-Make-configure-an-order-only-prerequisite-of-aconfig.h.in.patch

BuildRequires: autoconf
BuildRequires: gcc
BuildRequires: make
BuildRequires: readline-devel
BuildRequires: systemd-rpm-macros

%description
The Trivial File Transfer Protocol (TFTP) is normally used only for
booting diskless workstations.  The tftp package provides the user
interface for TFTP, which allows users to transfer files to and from a
remote machine.  This program and TFTP provide very little security,
and should not be enabled unless it is expressly needed.

%package server
Summary: The server for the Trivial File Transfer Protocol (TFTP)
Requires: systemd-units
Requires(post): systemd-units
Requires(postun): systemd-units

%description server
The Trivial File Transfer Protocol (TFTP) is normally used only for
booting diskless workstations.  The tftp-server package provides the
server for TFTP, which allows users to transfer files to and from a
remote machine. TFTP provides very little security, and should not be
enabled unless it is expressly needed.  The TFTP server is run by using
systemd socket activation, and is disabled by default.

%package doc
Summary: Documents for %{name}
BuildArch: noarch
Requires: %{name} = %{EVR}

%description doc
Doc pages for %{name}.

%prep
%autosetup -n %{name}-hpa-%{version} -p1

%build
autoreconf
%configure
%make_build

%install
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man{1,8}
mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/lib/tftpboot
mkdir -p ${RPM_BUILD_ROOT}%{_unitdir}

make INSTALLROOT=${RPM_BUILD_ROOT} SBINDIR=%{_sbindir} MANDIR=%{_mandir} INSTALL='install -p' install

install -p -m 644 %SOURCE1 ${RPM_BUILD_ROOT}%{_unitdir}
install -p -m 644 %SOURCE2 ${RPM_BUILD_ROOT}%{_unitdir}

%generate_compatibility_deps

%post server
%systemd_post tftp.socket

%preun server
%systemd_preun tftp.socket

%postun server
%systemd_postun_with_restart tftp.socket

%files
%{_bindir}/tftp
%dir %{abidir}
%{abidir}/tftp-option.list
%{_mandir}/man1/*

%files server
%dir %{_localstatedir}/lib/tftpboot
%{_sbindir}/in.tftpd
%{_mandir}/man8/*
%{_unitdir}/*

%files doc
%doc README README.security CHANGES

%changelog
* Wed Mar 15 2023 yuanhui <yuanhui@linux.alibaba.com> - 5.2-1
- Init tftp for AnolisOS 23
